;;;; remote-mailbox-test.scm

; should run multiple senders
;
; doesn't have good shutdown of socket
;
;X should have a better way to terminate the tcp-server loop
; - close the port

(import scheme
  (chicken base)
  (chicken process-context)
  (chicken process)
  (chicken format)
  (srfi 1)
  (srfi 18)
  miscmacros
  exn-condition
  mailbox
  #;remote-mailbox-adapter
  remote-mailbox-client
  remote-mailbox-service)

(define-constant NUM-MSG 5)
(define-constant RCV-NAM "Wong Foo")
(define MB-NAM 'wong-foo)

;sender (client) can talk to many servers
(define (sender)
  (print "* Sending " NUM-MSG " messages")
  (let ((rmb (make-remote-mailbox MB-NAM)))
    (dotimes (n NUM-MSG)
      ;a message can be any object
      (let ((msg `(message (recipient ,RCV-NAM) (id ,n))))
        (format #t "Sending |~S| to ~S~%" msg MB-NAM)
        (remote-mailbox-send! rmb msg) ) )
    (format #t "Sending |~S| to ~S~%" 'quit MB-NAM)
    (remote-mailbox-send! rmb 'quit))
    #; ;???
    (close-output-port (serializer-output)) )

;receiver (server) can talk to many clients
(define (receiver)
  (let ((mb (remote-mailbox-service MB-NAM #t #;RCV-NAM)))
    (handle-exceptions ex
      (begin (write-exn-condition ex) (newline))
      ;
      (print "* Receiving messages until quit...")
      (let receive-loop ()
        (let ((msg (mailbox-receive! mb)))
          (format #t "Received |~S| from ~S~%" msg MB-NAM)
          (unless (eq? 'quit msg)
            (receive-loop) ) ) )
      (print "stopping mailbox server...")
      (remote-mailbox-service-stop!) ) ) )

;;;

(define operation
  (let ((args (command-line-arguments)))
    (and (pair? args)
         (string->symbol (last args))) ) )

(if operation
  ;then know what to do
  (case operation
    ((sender)
      (sender) )
    ((receiver)
      (receiver) )
    (else
      (error 'remote-mailbox-test "unrecognized operation: " operation) ) )
  ;else test w/ this binary
  (let ((cmd (first (argv))))
    ;the "server" MUST be started before the client!
    (print "Running Receiver: " cmd)
    ;csi args are ignored by this as a compiled binary - last arg is ours
    (process-run cmd `("-n" "-s" ,(program-name) "receiver"))
    ;wait for receiver to startup
    (sleep 1)
    ;then start the sender
    (print "Running Sender: " cmd)
    ;this process not continuing
    ;(process-execute cmd `("-n" "-s" ,(program-name) "sender"))
    (sender) ) )
